import pyvisa
import AWG_7000




try:
    # Initialize VISA
    rm = pyvisa.ResourceManager()

    # List connected resources
    resources = rm.list_resources()
    print(f"\n\n\nConnected devices: {resources}")

    #Instrument TCP/IP address
    address_listed = resources[1]
    address_not_listed = "TCPIP0::192.168.0.55::inst0::INSTR"

    #If you use NI MAX or similar, you can also use one of the adresses in the list 
    master = rm.open_resource(address_not_listed)

    #Master Encoding: Necessary if you use non-ascii characters, like accented vocals.
    master.encoding = "latin-1"

    #Initialize AWG
    AWG = AWG_7000.AWG7000(master)
except Exception as e: print(f"The following exception has occured while connecting with the instrument: {e}")




##################################################################################
#Sequencer parameters
format = AWG_7000.Format.Amplitude_offset
analog_waveform_names = [["SINE", "SINE"],
                  ["RAMP", "RAMP"],
                  ["SQUARE", "SQUARE"]]
amplitudes = [[1, 1.5],
               [0.75, 0.75],
               [1, 1.2]]
offsets = [[0, 0],
            [0, 0.3],
            [0, 0]]
decreasing_strategies = [[AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation],
                         [AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation],
                         AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation]
increasing_strategies = [[AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation],
                         [AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation],
                         [AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation]]
sub_lengths = [[16384, 16384],
               [16384, 16384],
               [16384, 16384]]
delays = [[0, 0],
          [0, 0],
          [0, 0]]
output_formats = [[AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform],
                  [AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform],
                  [AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform]]
entry_lengths = [16384, 16384, 16384]
repetitions = [1, 1, 1]
sequencer_length = len(analog_waveform_names)

#Digital parameters
digital_channels = AWG_7000.ChannelsNumber.Eight
digital_pod = AWG_7000.Pod.PodA
skew = 0
digital_voltage_level = 3
digital_waveforms = ["COUNTER", "COUNTER", "COUNTER"]
marker_custom_pattern = ["CLOCK", "CLOCK", "CLOCK"]
CML_level = AWG_7000.CMLVoltageLevel.mV590

#General settings
wait_trigger_on = AWG_7000.WaitTriggerState.First_sample

#Trigger settings
trigger_impedance = AWG_7000.Impedance.High
trigger_slope = AWG_7000.Slope.Positive
trigger_source = AWG_7000.TriggerInSource.Timer
trigger_threshold = 1
trigger_timing_mode = AWG_7000.TriggerTiming.Slow
trigger_delay = 0
##################################################################################




try:
    AWG.Initialize(True)

    AWG.ConfigureGeneralSettings(AWG_7000.OperatingMode.Full_rate, AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.DecreasingStrategy.Decimation, AWG_7000.RunMode.Stepped,
                                 wait_trigger_on, 1, AWG_7000.BurstSelection.NumberCycles, AWG_7000.JumpMode.AfterRepetitions)
    
    for channel in AWG.channels:
        AWG.ConfigureChannelSettings(channel, 100, 0, 0, 0, 0, AWG_7000.KeepLastMode.CustomOnStop, AWG_7000.Polarity.Normal, 0, 0,
                                     AWG_7000.ChannelOptimization.High_Linearity, 0, AWG_7000.State.OFF, AWG_7000.KeepLastMode.KeepLast, 0)
        
    #for name in digital_waveforms:
    #    if name != "": AWG.ConfigureDigitalChannels(digital_channels, digital_pod, digital_voltage_level, AWG_7000.SetValue.PRESENT, CML_level, 0, AWG_7000.SetValue.DEFAULT, skew, AWG_7000.SetValue.PRESENT)
    #    AWG.SetDigitalsState(AWG_7000.State.ON)

    AWG.ConfigureMarkerOut(AWG_7000.Marker.Marker1, AWG_7000.MarkerMode.Custom_Pattern, 1, AWG_7000.SetValue.PRESENT, 0, AWG_7000.SetValue.PRESENT, 0, AWG_7000.SetValue.PRESENT)

    AWG.SetSequencerLength(sequencer_length, AWG_7000.SetValue.PRESENT)

    for i in range(sequencer_length):
        entry = AWG_7000.SequencerEntry(entry_number=i+1, analog_waveform_names=analog_waveform_names[i], amplitudes=amplitudes[i], offsets=offsets[i],
                                        decreasing_strategies=decreasing_strategies[i], increasing_strategies=increasing_strategies[i], sub_lengths=sub_lengths[i],
                                        delays=delays[i], digital_waveform_name=digital_waveforms[i], custom_pattern=marker_custom_pattern[i], length=entry_lengths[i],
                                        repetitions=repetitions[i], output_formats=output_formats[i])
        AWG.ConfigureSequencerElement(entry)

    AWG.ConfigureTriggerIn(trigger_source, 0.01, AWG_7000.SetValue.PRESENT, trigger_threshold, trigger_slope, trigger_impedance, trigger_timing_mode, trigger_delay)
    
    for channel in AWG.channels: AWG.SetOutputState(channel, AWG_7000.State.ON)

    AWG.AWGStart()
    AWG_on: bool = True




    #HMI
    while(True):
        command = input(f"Command list:   c -> stop the AWG and close;\n\t\ts -> start or stop the AWG;\n\t\tt -> send trigger\nDial command here: ")
        if command == "c":
            AWG.AWGStop()
            AWG.Close()
            AWG_on = False
            break
        elif command == "s":
            if AWG_on:
                AWG.AWGStop()
                AWG_on = False
            else:
                AWG.AWGStart()
                AWG_on = True
        elif command == "t": AWG.SendTrigger()
        else: print("Command not recognized\n")

except Exception as e: print(f"The following exception has occured: {e}")